package IteratorTask;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/*
 * @author SOLA
 * Class representing a graph structure.
 * **/
public class Graph {

	// Store vertices and their respective edges
	private Map<Integer, List<Integer>> vertex_edge_map = null;

	public Graph() {
		vertex_edge_map = new HashMap<>();
	}

	/**
	 * Function to add new vertex to the graph
	 */
	public void addVertex(int vertex) {
		if (!vertex_edge_map.containsKey(vertex)) {
			vertex_edge_map.put(vertex, new LinkedList<Integer>());
		}
	}

	/**
	 * Function to add new edge to the graph
	 */
	public void addEdge(Edge edge) {
		int source = edge.getSource();
		int destination = edge.getDestination();
		
		if (!vertex_edge_map.containsKey(source))
			addVertex(source);
		if (!vertex_edge_map.containsKey(destination))
			addVertex(destination);
		if (!vertex_edge_map.get(source).contains(destination))
			vertex_edge_map.get(source).add(destination);
	}

}
